/*
 *
 * maild ist ein kleines Programm, welches unter X11 im Hintergrund luft und
 * wartet, ob neue Emails reinkommen. Wenn eine (oder mehrere) neue mails da sind, 
 * dann gibt das Programm einen Beep Ton aus und zeigt ein kleines Fenster mit einem
 * Bild(eins liegt dieser Package bei, man kann aber natrlich auch sein eigenes hernehmen)
 * an, bzw. wenn es kein Bild findet, ein kleines rotes Xterm Fenster.
 *
 * maild ist weitgehend konfigurierbar. So kann man einstellen, wie oft das Programm nach
 * der Mailbox schauen soll, welches Bild angezeigt werden soll, usw. Genauere Informationen
 * dazu kannst Du dem beiliegenden README File entnehmen.
 *
 * Hinweise zur Installation befinden sich auch im README File.
 *
 * maild.cpp Version 0.2
 * 
 * (c) 1998 Thomas Linden
 * All rights reserved.
 * maild.cpp
 * 
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 * 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by THOMAS LINDEN
 *      and other contributors.
 * 4. Neither the name of THOMAS LINDEN nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THOMAS LINDEN ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THOMAS LINDEN BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * Thomas Linden
 * Email: tom@artix.net
 * Mail Comments and Bugreports about maild to: maild@artix.net
 */

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>


int initdaemon()
{
        pid_t pid;
        char temp[60] = "/home/";
        strcat(temp, getenv("USER"));
        strcat(temp, "/.maild.PID");   // Erzeuge Dateinamen fr PID Datei
        ifstream pid_file(temp);
        if( !pid_file )                 
        {
              // Datei existiert noch nicht, Datei anlegen  
              // erzeuge Child Process:
              if((pid = fork()) < 0)   
              {
                   return(-1);
              }
              // Schreibe PID in die PID Datei
              else if (pid != 0)
              {
                   ofstream pid_create;
                   pid_create.open(temp);
                   pid_create << pid << endl;
                   exit(0);
              }
              //Child luft weiter 
              setsid();
              chdir("/");
              umask(0);
        }
        else
        {
              cout << "ERROR: I have found an existing .maild.PID file!\n"
                   << "maild is already running for user " << getenv("USER")  
                   << ". If not, try to delete these file manually.\n";  
              exit(1);
        }
        return(0);
}

static void sighandler(int signo)
{
        // Signal Handler, Was ist bei welchem Signal zu tun?
        // Erzeuge Dateinamen
        char del_pidfile[60]="rm ";
        char tmp[60] = "/home/";
        strcat(tmp, getenv("USER"));
        strcat(tmp, "/.maild.PID");
        strcat(del_pidfile, tmp);
        switch(signo)
        {
                case SIGINT:
                     // Ist eigentlich Unsinn, na ja...
                     cout << "\nmaild: CRTL-C pressed. maild aborted!\n";
                     system(del_pidfile);                
                case SIGTERM:
                     // maild wurde normal beendet (kill -TERM 1111)
                     system(del_pidfile);
                     cout << "\nmaild: SIGTERM received. maild terminated.\n";
                     exit(0);
                     break;
                case SIGHUP:
                     // Neustart, bzw. Neuer Child Process durch Aufruf von initdaemon
                     cout << "\nmaild: SIGHUP received. maild restarted.\n";
                     system(del_pidfile);
                     initdaemon();
                     if (signal(SIGHUP, sighandler) == SIG_ERR)
                         cerr << "Warning: Can't Reset Signal Handler!\n";
                     break;
        }
        return;
}

int mail(int alt_, char command_[60], char *m_box)
{
	// Mail Handler, der macht die eigentliche Arbeit, (Piep usw...)
	struct stat attrib;
	int i=0;
	int neu_ = 0;
	i = 0;
	stat(m_box, &attrib);
	neu_ = attrib.st_size; // Grsse der Mailbox
	if((alt_ < neu_) || ((alt_ > neu_) && (neu_ > 0)))
	{
		system("echo -e '\a'"); // Piep 
		system(command_);       // xpm anzeigen(oder xterm, wenn xpm nicht da)
		alt_ = neu_;
	}
	return alt_;
}

void main()
{
        //Signal Handler installieren
        if(signal(SIGINT, sighandler) == SIG_ERR)          //CRTL-C
              cout << "Warning, cannot catch SIGINT\n";
        if(signal(SIGTERM, sighandler) == SIG_ERR)         //Terminiert
              cout << "Warning, cannot catch SIGTERM\n";
        if(signal(SIGHUP, sighandler) == SIG_ERR)          //Restart
              cout << "Warning, cannot catch SIGHUP\n";
        
        int d = 1, seconds = 0, tmp = 0, alt = 0, allready = 0;
        char array[5][5][80], c;
        char *pic, *mailbox, *altcommand, *sec, command[60], HOME[60], *user;
        int zeile=0, wort=0, zeichen=0, nix=0;
        // Dateinamen erzeugen(Konfig-file)
        user = getenv("USER");
        strcat(HOME, "cd /home/");
        strcat(HOME, user);        
        system(HOME);
        strcpy(HOME,"");
        strcat(HOME, "/home/");
        strcat(HOME, user);
        strcat(HOME, "/.maild");
        ifstream config_file(HOME);
        if ( !config_file )
        {
                // Konfig nicht gefunden, also Eine erzeugen
                ofstream create_config;
                create_config.open(HOME);
                create_config << "#  Konfiguration fr maild\n"
                              << "#  Ein Mailreminder.\n"
                              << "#  (c) 1998 Thomas Linden\n#\n"
                              << "#  Details bitte dem README File entnehmen!\n"
                              << "mailbox=/var/spool/mail/YOUR_USERNAME_HERE\n"
                              << "notifypic=$HOME/box.xpm\n"
                              << "altcommand=xterm +sb -bg red -cr red -geometry 10x4 &\n"
                              << "sec=30\n";
                cerr << "Config File not found. It was generated a new one in your Home\n"
                     << "But you have to restart maild!\n";
                exit(1);
        }
        else
        { 
                while ( config_file )
                {
                      config_file.get(c);
                      if (c == '#')
                      {
                          nix = 1;
                      }
                      if (c != '\n' && c != '=' && nix != 1)
                      {
                          array[zeile][wort][zeichen] = c;
                          zeichen++;
                      }
                      else if (c == '=' && nix != 1)
                      {
                          wort++;
                          zeichen = 0;
                      }
                      else if (c == '\n' || c == '\0')
                      {
                          zeile++;
                          wort = 0;
                          zeichen = 0;
                          if(nix == 1)
                          {
                                nix = 0;
                                zeile--;
                          }
                      }

                } 
        }
        
        if((strcmp(array[0][0], "mailbox")!=0) || (strcmp(array[1][0], "notifypic")!=0) || (strcmp(array[2][0], "altcommand")!=0))
        {
                   cerr << "Fehler: Fehlerhafte Konfigurationsdatei\n"
                        << "Konnte einen oder mehrere Parameter nicht finden!\n";
                   exit(1);
        }
        else
        {
                mailbox = array[0][1];
                pic = array[1][1];
                altcommand = array[2][1];
                sec = array[3][1];
                seconds = atoi(sec);
        }
        
        
        ifstream pic_file(pic);
        if( !pic_file )
        {
                strcat(command, "xterm +sb -bg red -cr red -geometry 10x4 &");
        }
        else 
        {
                strcat(command, "xv +viewonly ");
                strcat(command, pic);
                strcat(command, " &");
        }
        initdaemon(); //Child starten, Parent killen        
        while(d = 1)
        {
            time_t t;
            t = time(NULL);
            t =+ seconds;
            time_t T;
            T = time(NULL);
            while(T < t)
            {
                T = time(NULL);
            }
            tmp = mail(alt, command, mailbox);
            alt = tmp;
        }
}   
            
        
	

